Imports System.Data.OleDb

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents dgContacts As System.Windows.Forms.DataGrid
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.dgContacts = New System.Windows.Forms.DataGrid
        CType(Me.dgContacts, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'dgContacts
        '
        Me.dgContacts.DataMember = ""
        Me.dgContacts.Dock = System.Windows.Forms.DockStyle.Fill
        Me.dgContacts.HeaderForeColor = System.Drawing.SystemColors.ControlText
        Me.dgContacts.Location = New System.Drawing.Point(0, 0)
        Me.dgContacts.Name = "dgContacts"
        Me.dgContacts.Size = New System.Drawing.Size(560, 365)
        Me.dgContacts.TabIndex = 0
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(560, 365)
        Me.Controls.Add(Me.dgContacts)
        Me.Name = "Form1"
        Me.Text = "Form1"
        CType(Me.dgContacts, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Const TABLE_NAME As String = "Addresses"

    Private m_ConnectString As String

    Private m_DataAdapter As OleDbDataAdapter
    Private m_DataSet As DataSet

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Const SELECT_STRING As String = "SELECT * FROM " & TABLE_NAME & " ORDER BY FirstName, LastName"

        ' Get the database file name.
        Dim db_name As String = Application.StartupPath
        db_name = db_name.Substring(0, db_name.LastIndexOf("\"))
        db_name &= "\Contacts.mdb"

        ' Compose the connection string.
        m_ConnectString = _
              "Provider=Microsoft.Jet.OLEDB.4.0;" & _
              "Data Source=" & db_name & ";" & _
              "Persist Security Info=False"

        ' Create a DataAdapter to load the Addresses table.
        m_DataAdapter = New OleDbDataAdapter(SELECT_STRING, m_ConnectString)

        ' Create and fill the DataSet.
        m_DataSet = New DataSet
        m_DataAdapter.Fill(m_DataSet, TABLE_NAME)

        ' Bind the DataGrid to the DataTable.
        dgContacts.DataSource = m_DataSet.Tables("Addresses")
    End Sub

    ' Save changes to the data.
    Private Sub Form1_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        ' Use a CommandBuilder to make the INSERT command.
        Dim command_builder As New OleDbCommandBuilder(m_DataAdapter)

        ' Make a database connection.
        Dim conn As New OleDbConnection(m_ConnectString)

        ' Make the UPDATE command "by hand."
        Dim update_command As New OleDbCommand( _
            "UPDATE " & TABLE_NAME & " SET " & _
            "FirstName=?, LastName=?, Street=?, City=?, State=?, ZIP=? " & _
            "WHERE FirstName=? AND LastName=?", _
            conn)

        ' Define output parameters.
        update_command.Parameters.Add("@FirstName", OleDbType.VarWChar, 50, "FirstName")
        update_command.Parameters.Add("@LastName", OleDbType.VarWChar, 50, "LastName")
        update_command.Parameters.Add("@Street", OleDbType.VarWChar, 50, "Street")
        update_command.Parameters.Add("@City", OleDbType.VarWChar, 50, "City")
        update_command.Parameters.Add("@State", OleDbType.VarWChar, 2, "State")
        update_command.Parameters.Add("@ZIP", OleDbType.VarWChar, 10, "ZIP")

        ' Define intput (WHERE) parameters.
        Dim param As OleDbParameter
        param = update_command.Parameters.Add("@FirstName", OleDbType.VarWChar, 50, "FirstName")
        param.SourceVersion = DataRowVersion.Original
        param = update_command.Parameters.Add("@LastName", OleDbType.VarWChar, 50, "LastName")
        param.SourceVersion = DataRowVersion.Original

        ' Attach the update command to the DataAdapter.
        m_DataAdapter.UpdateCommand = update_command

        ' Make the DELETE command "by hand."
        Dim delete_command As New OleDbCommand( _
            "DELETE FROM " & TABLE_NAME & " " & _
            "WHERE FirstName=? AND LastName=?", _
            conn)

        ' Define intput (WHERE) parameters.
        param = delete_command.Parameters.Add("@FirstName", OleDbType.VarWChar, 50, "FirstName")
        param.SourceVersion = DataRowVersion.Original
        param = delete_command.Parameters.Add("@LastName", OleDbType.VarWChar, 50, "LastName")
        param.SourceVersion = DataRowVersion.Original

        ' Attach the delete command to the DataAdapter.
        m_DataAdapter.DeleteCommand = delete_command

        ' Update the database.
        Try
            m_DataAdapter.Update(m_DataSet, TABLE_NAME)
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub
End Class
